unit fann;

interface

uses system.types;

Const FANN_DLLFILE = 'fannfloat.dll';

type
  TFann_type = Single;

  PFann_Type  = ^TFann_type;
  PPFann_Type = ^PFann_type;
  Fann_Type_Array = array[word] of TFann_type;
  PFann_Type_Array = ^Fann_Type_Array;
  PPFann_Type_Array = ^PFann_Type_Array;

  //struct _iobuf{
  //  char *_ptr; int _cnt; char *_base; int _flag;
  //  int _file; int _charbuf; int _bufsiz; char *_tmpfname;
  //}; typedef struct _iobuf FILE;
  _iobuf = packed record
    _ptr: PChar;
    _cnt: Integer;
    _base: PChar;
    _flag: Integer;
    _file: Integer;
    _charbuf: Integer;
    _bufsiz: Integer;
    _tmpfname: PChar;
  end;
  TFile = _iobuf;
  PFile = ^TFile;

  TEnumType=Cardinal;

  TFann_activationfunc_enum=(
    FANN_LINEAR,
    //臒lANeBuA01̏o
    FANN_THRESHOLD,
    //臒lANeBuA-11̏o
    FANN_THRESHOLD_SYMMETRIC,
    //VOChAłgpA0`1̏o
    FANN_SIGMOID,
    //VOChiKI`ߎAVOCh荂Őx͗A0`1̏o
    FANN_SIGMOID_STEPWISE,
    //Ώ̃VOCh֐AłgpA-1`1̏o
    FANN_SIGMOID_SYMMETRIC,
    //Ώ̼ӲޒiKI`ߎAΏ̼Ӳނ荂Őx͗A-1`1̏o
    FANN_SIGMOID_SYMMETRIC_STEPWISE,
    FANN_GAUSSIAN,
    FANN_GAUSSIAN_SYMMETRIC,
    FANN_GAUSSIAN_STEPWISE,
    FANN_ELLIOT,
    FANN_ELLIOT_SYMMETRIC,
    FANN_LINEAR_PIECE,
    FANN_LINEAR_PIECE_SYMMETRIC,
    FANN_SIN_SYMMETRIC,
    FANN_COS_SYMMETRIC,
    FANN_SIN,
    FANN_COS
  );

  PFann_activationfunc_enum = ^Tfann_activationfunc_enum;


  TFann_Neuron = packed record
    first_con: Cardinal;
    last_con : Cardinal;
    sum: TFann_type;
    value: TFann_type;
    activation_steepness: TFann_type;
    activation_function: Cardinal ;
  end;
  PFann_Neuron = ^TFann_Neuron;
  PPFann_Neuron = ^PFann_Neuron;

  TFann_Layer = packed record
    first_neuron: PFann_Neuron;
    last_neuron : PFann_Neuron;
  end;
  PFann_Layer = ^TFann_Layer;

  TFann_nettype_enum = TEnumType;
  TFann_errno_enum = TEnumType;

  TFann_train_enum =(
    //d݂1̃G|bNŉxXVobNvpQ[VASYB
    //ɑg[jO邪AxȖ͂܂g[jO܂B
    FANN_TRAIN_INCREMENTAL, //0
    //d݂̓G|bN1񂾂XV̂ŁAg[jOxȂ܂B
    //ϓ덷͂萳mɌvZAFANN_TRAIN_INCREMENTALǂB
    FANN_TRAIN_BATCH,       //1
    //K^̈learning_rategp܂BiRPROPASY
    FANN_TRAIN_RPROP,       //2
    //learning_rategpA荂xȃASYB
    FANN_TRAIN_QUICKPROP,   //3
    //SARPROPASY
    FANN_TRAIN_SARPROP      //4
  );
  TFann_errorfunc_enum=TEnumType;
  TFann_stopfunc_enum=TEnumType;

  PFann_Train_Data = ^TFann_Train_Data;
  TFann_Train_Data = packed record
    errno_f: TFann_errno_enum;
    erro_log: PFile;
    errstr: PChar;
    num_data: Cardinal;
    num_input: Cardinal;
    num_ouput: Cardinal;
    input: PPFann_Type_Array;
    output: PPFann_Type_Array;
  end;

  PFann = ^TFann;

  TFann_callback = function(
    ann: PFann;
    train: PFann_Train_Data;
    max_epochs: Cardinal;
    epochs_between_reports: Cardinal;
    desired_error: Single;
    epochs: Cardinal): Integer; stdcall;

  TUser_Function = procedure(
    num: Cardinal;
    num_input: Cardinal;
    num_output: Cardinal;
    input: PFann_Type;
    output: PFann_Type); stdcall;

  TFann = packed record
    errno_f: TFann_errno_enum;
    error_log: PFile;
    errstr: PChar;
    learning_rate: Single;
    learning_momentum: Single;
    connection_rate: Single;
    network_type: TFann_nettype_enum;
    first_layer: PFann_Layer;
    last_layer: PFann_Layer;
    total_neurons: Cardinal;
    num_input: Cardinal;
    num_output: Cardinal;
    weights: PFann_Type;
    connections: PPFann_Neuron;
    train_errors: PFann_Type;
    training_algorithm: TFann_train_enum;
    total_connections: Cardinal;
    output: PFann_Type;
    num_MSE: Cardinal;
    MSE_value: Single;
    num_bit_fail: Cardinal;
    bit_fail_limit: TFann_type;
    train_error_function: TFann_errorfunc_enum;
    train_stop_function: Tfann_stopfunc_enum;
    callback: TFann_callback;
    user_data: Pointer;
    cascade_output_change_fraction: single;
    cascade_output_stagnation_epochs: Cardinal;
    cascade_candidate_change_fraction: single;
    cascade_candidate_stagnation_epochs: Cardinal;
    cascade_best_candidate: Cardinal;
    cascade_candidate_limit: TFann_type;
    cascade_weight_multiplier: TFann_type;
    cascade_max_out_epochs: Cardinal;
    cascade_max_cand_epochs: Cardinal;
    cascade_activation_functions: TFann_activationfunc_enum;
    cascade_activation_functions_count: Cardinal;
    cascade_activation_steepnesses: PFann_Type;
    cascade_activation_steepnesses_count: Cardinal;
    cascade_num_candidate_groups: Cardinal;
    cascade_candidate_scores: PFann_Type;
    total_neurons_allocated: Cardinal;
    total_connections_allocated: Cardinal;
    quickprop_decay: single;
    quickprop_mu: single;
    rprop_increase_factor: single;
    rprop_decrease_factor: single;
    rprop_delta_min: single;
    rprop_delta_max: single;
    rprop_delta_zero: single;
    sarprop_temperature:single;
    sarprop_epoch: Cardinal;
    train_slopes: PFann_Type;
    prev_steps: PFann_Type;
    prev_train_slopes: PFann_Type;
    prev_weights_deltas: PFann_Type;
  end;

  TFann_Connection = packed record
    from_neuron: Cardinal;
    to_neuron: Cardinal;
    weight: TFann_type;
  end;
  PFann_Connection = ^TFann_Connection;

  TFann_Error = packed record
    errno_f: TFann_errno_enum;
    error_log: PFile;
    errstr: PChar;
  end;
  PFann_Error = ^TFann_Error;

Const
  //_Fann_Error_Func
  FANN_ERRORFUNC_LINEAR = 0;
  FANN_ERRORFUNC_TANH = 1;

  //_Fann_ErroNo
  FANN_E_NO_ERROR = 0;
  FANN_E_CANT_OPEN_CONFIG_R = 1;
  FANN_E_CANT_OPEN_CONFIG_W = 2;
  FANN_E_WRONG_CONFIG_VERSION = 3;
  FANN_E_CANT_READ_CONFIG = 4;
  FANN_E_CANT_READ_NEURON = 5;
  FANN_E_CANT_READ_CONNECTIONS = 6;
  FANN_E_WRONG_NUM_CONNECTIONS = 7;
  FANN_E_CANT_OPEN_TD_W = 8;
  FANN_E_CANT_OPEN_TD_R = 9;
  FANN_E_CANT_READ_TD = 10;
  FANN_E_CANT_ALLOCATE_MEM = 11;
  FANN_E_CANT_TRAIN_ACTIVATION = 12;
  FANN_E_CANT_USE_ACTIVATION = 13;
  FANN_E_TRAIN_DATA_MISMATCH = 14;
  FANN_E_CANT_USE_TRAIN_ALG = 15;
  FANN_E_TRAIN_DATA_SUBSET = 16;
  FANN_E_INDEX_OUT_OF_BOUND = 17;
  FANN_E_SCALE_NOT_PRESENT = 18;


  //_Fann_Stop_Func
  FANN_STOPFUNC_MSE = 0;
  FANN_STOPFUNC_BIT = 1;

  //_Fann_Net_Type
  FANN_NETTYPE_LAYER = 0;
  FANN_NETTYPE_SHORTCUT = 1;

  function fann_create_standard(num_layers: Cardinal): PFann; stdcall;
  function fann_create_sparse(
    connection_rate: single; num_layers: Cardinal):PFann; stdcall;
  function fann_create_shortcut(connection_rate: single): PFann; stdcall;
  function fann_create_standard_array(
    num_layers: Cardinal; const layers: PCardinal): PFann; stdcall;
  function fann_create_sparse_array(
    connection_rate: single; num_layers: Cardinal;
    const layers: PCardinal): PFann; stdcall;
  function fann_create_shortcut_array(
    num_layers: cardinal;const layers: Pcardinal): PFann; stdcall;
  procedure fann_destroy(Ann: PFann); stdcall;
  function fann_run(ann: PFann; input: PFann_Type): Pfann_type_array; stdcall;
  procedure fann_randomize_weights(
    Ann: PFann; Min_weight: TFann_type; Max_weight: TFann_type); stdcall;
  procedure fann_init_weights(
    Ann: PFann; train_data: PFann_Train_Data); stdcall;
  procedure fann_print_connections(ann: PFann);stdcall;
  procedure fann_print_parameters(ann: PFann);stdcall;
  function fann_get_num_input(Ann: PFann): cardinal;stdcall;
  function fann_get_num_output(Ann: PFann): cardinal;stdcall;
  function fann_get_total_neurons(Ann: PFann): cardinal; stdcall;
  function fann_get_total_connections(Ann: PFann): cardinal; stdcall;
  function fann_get_network_type(Ann: PFann): cardinal; stdcall;
  function fann_get_connection_rate(Ann: PFann): single; stdcall;
  function fann_get_num_layers(Ann: PFann): cardinal; stdcall;
  procedure fann_get_layer_array(Ann: PFann; layers: PCardinal); stdcall;
  procedure fann_get_bias_array(Ann: PFann; bias: PCardinal);stdcall;
  procedure fann_get_connection_array(
    Ann: PFann; connections: PFann_Connection);stdcall;
  procedure fann_set_weight_array(Ann: PFann;
    connections: PFann_Connection; num_connection: Cardinal);stdcall;
  procedure fann_set_weight(Ann: PFann;
    from_neuron: Cardinal; to_neuron: Cardinal; weight: TFann_type);stdcall;
  procedure fann_set_user_data(Ann: PFann; user_data: Pointer);stdcall;
  function fann_get_user_data(Ann: PFann): Pointer; stdcall;
  function fann_create_from_file(
    const configuration_file: PAnsiChar): PFann; stdcall;
  procedure fann_save(Ann: PFann; Const Configuration_File: PAnsiChar);stdcall;
  function fann_save_to_fixed(
    Ann: PFann; Const Configuration_File: PChar): integer;stdcall;
  procedure fann_train(
    Ann: PFann; Input: PFann_Type; Desired_Output: PFann_Type);stdcall;
  function fann_test(
    Ann: PFann; Input: PFann_Type;
    Desired_Output: Pfann_Type): Pfann_type_array;stdcall;
  function fann_get_MSE(Ann: PFann): single;stdcall;
  function fann_get_bit_fail(Ann: PFann): Cardinal;stdcall;
  procedure fann_reset_MSE(Ann: Pfann); stdcall;
  procedure fann_train_on_data(
    Ann: PFann; Data: PFann_Train_Data;
    max_epochs: cardinal;epochs_between_reports: cardinal;
    desired_error: single);stdcall;
  procedure fann_train_on_file(
    Ann: PFann; Filename: PAnsiChar;max_epochs: cardinal;
    epochs_between_reports: cardinal; desired_error: single); stdcall;
  function fann_train_epoch(
    Ann: PFann; data: PFann_Train_Data): single; stdcall;
  function fann_test_data(Ann: PFann; data: PFann_Train_Data): single; stdcall;
  function fann_read_train_from_file(
    const filename: PChar): PFann_Train_Data; stdcall;
  function fann_create_train_from_callback(
    num_data: Cardinal; num_input: Cardinal;
    num_output: Cardinal;
    user_function: TUser_Function): PFann_Train_Data; stdcall;
  procedure fann_destroy_train(train_data: PFann_Train_Data); stdcall;
  procedure fann_shuffle_train_data(Train_Data: PFann_Train_Data);stdcall;
  procedure fann_scale_train(Ann: PFann; data: PFann_Train_Data);stdcall;
  procedure fann_descale_train(Ann: PFann; data: PFann_Train_Data);stdcall;
  function fann_set_input_scaling_params(
    Ann: PFann; const data: PFann_Train_Data;
    new_input_min: single; new_input_max: single): integer;stdcall;
  function fann_set_output_scaling_params(
    Ann: PFann; const data: PFann_Train_Data;
    new_output_min: single; new_output_max: single): integer;stdcall;
  function fann_set_scaling_params(
    Ann: PFann; const data: PFann_Train_Data;
    new_input_min: single; new_input_max: single;
    new_output_min: single; new_output_max: single): integer; stdcall;
  function fann_clear_scaling_params(Ann: PFann): integer; stdcall;
  procedure fann_scale_input(Ann: PFann; input_vector: PFann_type); stdcall;
  procedure fann_scale_output(Ann: PFann; output_vector: PFann_type); stdcall;
  procedure fann_descale_input(Ann: PFann; input_vector: PFann_type); stdcall;
  procedure fann_descale_output(Ann: PFann; output_vector: PFann_type); stdcall;
  procedure fann_scale_input_train_data(
    Train_Data: PFann_Train_Data; new_min: TFann_type;
    new_max: TFann_type); stdcall;
  procedure fann_scale_output_train_data(
    Train_Data: PFann_Train_Data; new_min: TFann_type;
    new_max: TFann_type); stdcall;
  procedure fann_scale_train_data(
    Train_Data: PFann_Train_Data; new_min: TFann_type;
    new_max: TFann_type); stdcall;
  function fann_merge_train_data(
    Data1: PFann_Train_Data; Data2:
    PFann_Train_Data): PFann_Train_Data; stdcall;
  function fann_duplicate_train_data(
    Data: PFann_Train_Data): PFann_Train_Data;stdcall;
  function fann_subset_train_data(
    data: PFann_Train_Data; pos: Cardinal;
    length: Cardinal): PFann_Train_Data; stdcall;
  function fann_length_train_data(
    data: PFann_Train_Data): Cardinal; stdcall;
  function fann_num_input_train_data(
    data: PFann_Train_Data): Cardinal; stdcall;
  function fann_num_output_train_data(
    data: PFann_Train_Data): Cardinal; stdcall;
  function fann_save_train(
    Data: PFann_train_Data; const Filename: PChar):integer;stdcall;
  function fann_save_train_to_fixed(
    Data: PFann_train_Data; const FileName: Pchar;
    decimal_point: cardinal): integer;stdcall;
  function fann_get_training_algorithm(Ann: Pfann):Cardinal;stdcall;
  procedure fann_set_training_algorithm(
    Ann: PFann; Training_Algorithm: Cardinal);stdcall;
  function fann_get_learning_rate(Ann: PFann): single;stdcall;
  procedure fann_set_learning_rate(
    Ann: PFann; Learning_Rate: Single); stdcall;
  function fann_get_learning_momentum(Ann: PFann): single;stdcall;
  procedure fann_set_learning_momentum(
    Ann: PFann; learning_momentum: Single); stdcall;
  function fann_get_activation_function(
    Ann: PFann; layer: integer;
    neuron: integer): TFann_activationfunc_enum; stdcall;
  procedure fann_set_activation_function(
    Ann: PFann; activation_function: Cardinal;
    layer: integer; neuron: integer); stdcall;
  procedure fann_set_activation_function_layer(
    Ann: PFann; activation_function: Cardinal;
    layer: integer); stdcall;
  procedure fann_set_activation_function_hidden(
    Ann: PFann; activation_function: Cardinal);  stdcall;
  procedure fann_set_activation_function_output(
    Ann: PFann; activation_function: Cardinal); stdcall;
  function fann_get_activation_steepness(
    Ann: PFann; layer: integer; neuron: integer): TFann_type; stdcall;
  procedure fann_set_activation_steepness(
    Ann: PFann; steepness: TFann_type;
    layer: integer; neuron: integer); stdcall;
  procedure fann_set_activation_steepness_layer(
    Ann: PFann; steepness: TFann_type; layer: integer); stdcall;
  procedure fann_set_activation_steepness_hidden(
    Ann: PFann; steepness: TFann_type); stdcall;
  procedure fann_set_activation_steepness_output(
    Ann: PFann; steepness: TFann_type); stdcall;
  function fann_get_train_error_function(Ann: PFann): cardinal;stdcall;
  procedure fann_set_train_error_function(
    Ann: PFann; Train_Error_Function: cardinal); stdcall;
  function fann_get_train_stop_function(Ann: PFann): Cardinal; stdcall;
  procedure fann_set_train_stop_function(
    Ann: PFann; train_stop_function: cardinal); stdcall;
  function fann_get_bit_fail_limit(Ann: PFann): TFann_type; stdcall;
  procedure fann_set_bit_fail_limit(
    Ann: PFann; bit_fail_limit: TFann_type); stdcall;
  procedure fann_set_callback(Ann: PFann; callback: TFann_Callback); stdcall;
  function fann_get_quickprop_decay(Ann: PFann): single;stdcall;
  procedure fann_set_quickprop_decay(
    Ann: Pfann; quickprop_decay: Single);stdcall;
  function fann_get_quickprop_mu(Ann: PFann): single;stdcall;
  procedure fann_set_quickprop_mu(Ann: PFann; Mu: Single);stdcall;
  function fann_get_rprop_increase_factor(Ann: PFann): single;stdcall;
  procedure fann_set_rprop_increase_factor(
    Ann: PFann;rprop_increase_factor: single);stdcall;
  function fann_get_rprop_decrease_factor(
    Ann: PFann): single;stdcall;
  procedure fann_set_rprop_decrease_factor(
    Ann: PFann;rprop_decrease_factor: single); stdcall;
  function fann_get_rprop_delta_min(Ann: PFann): single; stdcall;
  procedure fann_set_rprop_delta_min(
    Ann: PFann; rprop_delta_min: Single); stdcall;
  function fann_get_rprop_delta_max(Ann: PFann): single;stdcall;
  procedure fann_set_rprop_delta_max(
    Ann: PFann; rprop_delta_max: Single); stdcall;
  function fann_get_rprop_delta_zero(Ann: PFann): single;stdcall;
  procedure fann_set_rprop_delta_zero(
    Ann: PFann; rprop_delta_zero: Single); stdcall;
  procedure fann_set_error_log(errdat: PFann_Error; Log_File: PFile);stdcall;
  function fann_get_errno(errdat: PFann_Error): cardinal;stdcall;
  procedure fann_reset_errno(errdat: PFann_Error);stdcall;
  procedure fann_reset_errstr(errdat: PFann_Error);stdcall;
  function fann_get_errstr(errdat: PFann_Error): PChar;stdcall;
  procedure fann_print_error(Errdat: PFann_Error);stdcall;
  procedure fann_cascadetrain_on_data(
    Ann: PFann; data: PFann_Train_Data;
    max_neurons: Cardinal; neurons_between_reports: Cardinal;
    desired_error: single); stdcall;
  procedure fann_cascadetrain_on_file(Ann: PFann; const filename: PChar;
    max_neurons: Cardinal; neurons_between_reports: Cardinal;
    desired_error: single); stdcall;
  function fann_get_cascade_output_change_fraction(
    Ann: PFann): single; stdcall;
  procedure fann_set_cascade_output_change_fraction(
    Ann: PFann; cascade_output_change_fraction: single); stdcall;
  function fann_get_cascade_output_stagnation_epochs(
    Ann: PFann): cardinal; stdcall;
  procedure fann_set_cascade_output_stagnation_epochs(
    Ann: PFann; cascade_output_stagnation_epochs: cardinal); stdcall;
  function fann_get_cascade_candidate_change_fraction(
    Ann: PFann): single; stdcall;
  procedure fann_set_cascade_candidate_change_fraction(
    Ann: PFann; cascade_candidate_change_fraction: single); stdcall;
  function fann_get_cascade_candidate_stagnation_epochs(
    Ann: PFann): cardinal; stdcall;
  procedure fann_set_cascade_candidate_stagnation_epochs(
    Ann: PFann; cascade_candidate_stagnation_epochs: cardinal); stdcall;
  function fann_get_cascade_weight_multiplier(
    Ann: PFann): TFann_type; stdcall;
  procedure fann_set_cascade_weight_multiplier(
    Ann: PFann; cascade_weight_multiplier: TFann_type); stdcall;
  function fann_get_cascade_candidate_limit(
    Ann: PFann): TFann_type; stdcall;
  procedure fann_set_cascade_candidate_limit(
    Ann: PFann; cascade_candidate_limit: TFann_type); stdcall;

  function fann_get_cascade_max_out_epochs(Ann: PFann): cardinal; stdcall;
  procedure fann_set_cascade_max_out_epochs(
    Ann: PFann; cascade_max_out_epochs: cardinal); stdcall;
  function fann_get_cascade_max_cand_epochs(
    Ann: PFann): cardinal; stdcall;
  procedure fann_set_cascade_max_cand_epochs(
    Ann: PFann; cascade_max_cand_epochs: cardinal); stdcall;
  function fann_get_cascade_num_candidates(
    Ann: PFann): cardinal; stdcall;
  function fann_get_cascade_activation_functions_count(
    Ann: PFann): cardinal; stdcall;
  function fann_get_cascade_activation_functions(
    Ann: PFann): PCardinal; stdcall;
  procedure fann_set_cascade_activation_functions(Ann: PFann;
    cascade_activation_functions: PCardinal;
    cascade_activation_functions_count: Cardinal); stdcall;
  function fann_get_cascade_activation_steepnesses_count(
    Ann: PFann): cardinal; stdcall;
  function fann_get_cascade_activation_steepnesses(
    Ann: PFann): pfann_type; stdcall;
  procedure fann_set_cascade_activation_steepnesses(
    Ann: PFann; cascade_activation_steepnesses: PFann_Type;

    cascade_activation_steepnesses_count: Cardinal); stdcall;

  function fann_get_cascade_num_candidate_groups(Ann: PFann): cardinal; stdcall;
  procedure fann_set_cascade_num_candidate_groups(
    Ann: PFann; cascade_num_candidate_groups: cardinal); stdcall;

implementation

  function fann_create_standard; external FANN_DLLFILE;
  function fann_create_sparse; external FANN_DLLFILE;
  function fann_create_shortcut; external FANN_DLLFILE;
  function fann_create_standard_array;
    external FANN_DLLFILE name '_fann_create_standard_array@8';
  function fann_create_sparse_array;
    external FANN_DLLFILE name '_fann_create_sparse_array@12';
  function fann_create_shortcut_array; external FANN_DLLFILE;
  procedure fann_destroy(Ann: PFann);
    external FANN_DLLFILE name '_fann_destroy@4';
  function fann_run; external FANN_DLLFILE name '_fann_run@8';
  procedure fann_randomize_weights;
    external FANN_DLLFILE name '_fann_randomize_weights@12';
  procedure fann_init_weights; external FANN_DLLFILE;
  procedure fann_print_connections; external FANN_DLLFILE;
  procedure fann_print_parameters; external FANN_DLLFILE;
  function fann_get_num_input; external FANN_DLLFILE;
  function fann_get_num_output; external FANN_DLLFILE;
  function fann_get_total_neurons; external FANN_DLLFILE;
  function fann_get_total_connections;
    external FANN_DLLFILE name '_fann_get_total_connections@4';
  function fann_get_network_type; external FANN_DLLFILE;
  function fann_get_connection_rate;
    external FANN_DLLFILE name '_fann_get_connection_rate@4';
  function fann_get_num_layers;
    external FANN_DLLFILE name '_fann_get_num_layers@4';
  procedure fann_get_layer_array;
    external FANN_DLLFILE name '_fann_get_layer_array@8';
  procedure fann_get_bias_array;
    external FANN_DLLFILE name '_fann_get_bias_array@8';
  procedure fann_get_connection_array;
    external FANN_DLLFILE name '_fann_get_connection_array@8';
  procedure fann_set_weight_array; external FANN_DLLFILE;
  procedure fann_set_weight; external FANN_DLLFILE;
  procedure fann_set_user_data; external FANN_DLLFILE;
  function fann_get_user_data; external FANN_DLLFILE;
  function fann_create_from_file;
    external FANN_DLLFILE name '_fann_create_from_file@4';
  procedure fann_save; external FANN_DLLFILE name '_fann_save@8';
  function fann_save_to_fixed; external FANN_DLLFILE;
  procedure fann_train; external FANN_DLLFILE name '_fann_train@12';
  function fann_test; external FANN_DLLFILE;
  function fann_get_MSE; external FANN_DLLFILE name '_fann_get_MSE@4';
  function fann_get_bit_fail; external FANN_DLLFILE;
  procedure fann_reset_MSE; external FANN_DLLFILE name '_fann_reset_MSE@4';
  procedure fann_train_on_data;
    external FANN_DLLFILE name '_fann_train_on_data@20';
  procedure fann_train_on_file;
    external FANN_DLLFILE name '_fann_train_on_file@20';
  function fann_train_epoch; external FANN_DLLFILE;
  function fann_test_data; external FANN_DLLFILE;
  function fann_read_train_from_file; external FANN_DLLFILE;
  function fann_create_train_from_callback; external FANN_DLLFILE;
  procedure fann_destroy_train; external FANN_DLLFILE;
  procedure fann_shuffle_train_data; external FANN_DLLFILE;
  procedure fann_scale_train; external FANN_DLLFILE;
  procedure fann_descale_train; external FANN_DLLFILE;
  function fann_set_input_scaling_params; external FANN_DLLFILE;
  function fann_set_output_scaling_params; external FANN_DLLFILE;
  function fann_set_scaling_params; external FANN_DLLFILE;
  function fann_clear_scaling_params; external FANN_DLLFILE;
  procedure fann_scale_input; external FANN_DLLFILE;
  procedure fann_scale_output; external FANN_DLLFILE;
  procedure fann_descale_input; external FANN_DLLFILE;
  procedure fann_descale_output; external FANN_DLLFILE;
  procedure fann_scale_input_train_data; external FANN_DLLFILE;
  procedure fann_scale_output_train_data; external FANN_DLLFILE;
  procedure fann_scale_train_data; external FANN_DLLFILE;
  function fann_merge_train_data; external FANN_DLLFILE;
  function fann_duplicate_train_data; external FANN_DLLFILE;
  function fann_subset_train_data; external FANN_DLLFILE;
  function fann_length_train_data; external FANN_DLLFILE;
  function fann_num_input_train_data; external FANN_DLLFILE;
  function fann_num_output_train_data; external FANN_DLLFILE;
  function fann_save_train; external FANN_DLLFILE;
  function fann_save_train_to_fixed; external FANN_DLLFILE;
  function fann_get_training_algorithm;
    external FANN_DLLFILE name '_fann_get_training_algorithm@4';
  procedure fann_set_training_algorithm;
    external FANN_DLLFILE name '_fann_set_training_algorithm@8';
  function fann_get_learning_rate;
    external FANN_DLLFILE name '_fann_get_learning_rate@4';
  procedure fann_set_learning_rate;
    external FANN_DLLFILE name '_fann_set_learning_rate@8';
  function fann_get_learning_momentum;
    external FANN_DLLFILE name '_fann_get_learning_momentum@4';
  procedure fann_set_learning_momentum;
    external FANN_DLLFILE name '_fann_set_learning_momentum@8';
  function fann_get_activation_function; external FANN_DLLFILE;
  procedure fann_set_activation_function;
    external FANN_DLLFILE name '_fann_set_activation_function@16';
  procedure fann_set_activation_function_layer; external FANN_DLLFILE;
  procedure fann_set_activation_function_hidden;
    external FANN_DLLFILE name '_fann_set_activation_function_hidden@8';
  procedure fann_set_activation_function_output;
    external FANN_DLLFILE name '_fann_set_activation_function_output@8';
  function fann_get_activation_steepness; external FANN_DLLFILE;
  procedure fann_set_activation_steepness;
    external FANN_DLLFILE name '_fann_set_activation_steepness@16';
  procedure fann_set_activation_steepness_layer;
    external FANN_DLLFILE name '_fann_set_activation_steepness_layer@12';
  procedure fann_set_activation_steepness_hidden;
    external FANN_DLLFILE name '_fann_set_activation_steepness_hidden@8';
  procedure fann_set_activation_steepness_output;
    external FANN_DLLFILE name '_fann_set_activation_steepness_output@8';
  function fann_get_train_error_function; external FANN_DLLFILE;
  procedure fann_set_train_error_function; external FANN_DLLFILE;
  function fann_get_train_stop_function; external FANN_DLLFILE;
  procedure fann_set_train_stop_function; external FANN_DLLFILE;
  function fann_get_bit_fail_limit; external FANN_DLLFILE;
  procedure fann_set_bit_fail_limit; external FANN_DLLFILE;
  procedure fann_set_callback; external FANN_DLLFILE;
  function fann_get_quickprop_decay; external FANN_DLLFILE;
  procedure fann_set_quickprop_decay; external FANN_DLLFILE;
  function fann_get_quickprop_mu; external FANN_DLLFILE;
  procedure fann_set_quickprop_mu; external FANN_DLLFILE;
  function fann_get_rprop_increase_factor; external FANN_DLLFILE;
  procedure fann_set_rprop_increase_factor; external FANN_DLLFILE;
  function fann_get_rprop_decrease_factor; external FANN_DLLFILE;
  procedure fann_set_rprop_decrease_factor; external FANN_DLLFILE;
  function fann_get_rprop_delta_min; external FANN_DLLFILE;
  procedure fann_set_rprop_delta_min; external FANN_DLLFILE;
  function fann_get_rprop_delta_max; external FANN_DLLFILE;
  procedure fann_set_rprop_delta_max; external FANN_DLLFILE;
  function fann_get_rprop_delta_zero; external FANN_DLLFILE;
  procedure fann_set_rprop_delta_zero; external FANN_DLLFILE;
  procedure fann_set_error_log; external FANN_DLLFILE;
  function fann_get_errno; external FANN_DLLFILE;
  procedure fann_reset_errno; external FANN_DLLFILE;
  procedure fann_reset_errstr; external FANN_DLLFILE;
  function fann_get_errstr; external FANN_DLLFILE;
  procedure fann_print_error; external FANN_DLLFILE;
  procedure fann_cascadetrain_on_data; external FANN_DLLFILE;
  procedure fann_cascadetrain_on_file; external FANN_DLLFILE;
  function fann_get_cascade_output_change_fraction; external FANN_DLLFILE;
  procedure fann_set_cascade_output_change_fraction; external FANN_DLLFILE;
  function fann_get_cascade_output_stagnation_epochs; external FANN_DLLFILE;
  procedure fann_set_cascade_output_stagnation_epochs; external FANN_DLLFILE;
  function fann_get_cascade_candidate_change_fraction; external FANN_DLLFILE;
  procedure fann_set_cascade_candidate_change_fraction; external FANN_DLLFILE;
  function fann_get_cascade_candidate_stagnation_epochs; external FANN_DLLFILE;
  procedure fann_set_cascade_candidate_stagnation_epochs; external FANN_DLLFILE;
  function fann_get_cascade_weight_multiplier; external FANN_DLLFILE;
  procedure fann_set_cascade_weight_multiplier; external FANN_DLLFILE;
  function fann_get_cascade_candidate_limit; external FANN_DLLFILE;
  procedure fann_set_cascade_candidate_limit; external FANN_DLLFILE;

  function fann_get_cascade_max_out_epochs; external FANN_DLLFILE;
  procedure fann_set_cascade_max_out_epochs; external FANN_DLLFILE;
  function fann_get_cascade_max_cand_epochs; external FANN_DLLFILE;
  procedure fann_set_cascade_max_cand_epochs; external FANN_DLLFILE;
  function fann_get_cascade_num_candidates; external FANN_DLLFILE;
  function fann_get_cascade_activation_functions_count; external FANN_DLLFILE;
  function fann_get_cascade_activation_functions; external FANN_DLLFILE;
  procedure fann_set_cascade_activation_functions; external FANN_DLLFILE;
  function fann_get_cascade_activation_steepnesses_count; external FANN_DLLFILE;
  function fann_get_cascade_activation_steepnesses; external FANN_DLLFILE;
  procedure fann_set_cascade_activation_steepnesses; external FANN_DLLFILE;

  function fann_get_cascade_num_candidate_groups; external FANN_DLLFILE;
  procedure fann_set_cascade_num_candidate_groups; external FANN_DLLFILE;


end.

